/*
 * (c) Copyright 1992 by Panagiotis Tsirigotis
 * All rights reserved.  The file named COPYRIGHT specifies the terms 
 * and conditions for redistribution.
 */

#ifndef ACCESS_H
#define ACCESS_H

/*
 * $Id: access.h,v 5.1 1992/10/31 23:56:10 panos Exp $
 */

#define CF_ADDRESS				1
#define CF_TIME					2
#define CF_SERVICE_LIMIT		3
#define CF_PROCESS_LIMIT		4

typedef enum
   {
      AC_OK,               /* ok to start a server                         */
      AC_FORK,             /* tried to start a server but fork failed      */
      AC_ADDRESS,          /* we do not accept requests from that address  */
      AC_TIME,             /* we do not accept requests at this time       */
      AC_SERVICE_LIMIT,    /* server limit would be exceeded for this      */
                           /* service                                      */
      AC_PROCESS_LIMIT     /* total process limit would be exceeded        */
   } access_e ;

access_e access_control() ;

#endif	/* ACCESS_H */
