/*
 * (c) Copyright 1992 by Panagiotis Tsirigotis
 * All rights reserved.  The file named COPYRIGHT specifies the terms 
 * and conditions for redistribution.
 */

#ifndef LOG_H
#define LOG_H

/*
 * $Id: log.h,v 5.1 1992/10/31 23:59:07 panos Exp $
 */

/*
 * Meaning of logtype flags:
 *
 *    L_NONE:           no logging
 *    L_FILE:           log output goes to a file
 *    L_SYSLOG:         log output goes to syslog(3)
 *    L_COMMON_FILE:    log output goes to the file specified in defaults
 */
typedef enum { L_NONE = 0, L_FILE, L_SYSLOG, L_COMMON_FILE } logtype_e ;

struct filelog
{
   char *filename ;							/* always malloc'ed						*/
	unsigned soft_limit ;
	unsigned hard_limit ;
} ;

#define FILELOG_SIZE_CONTROL( flp )		( flp->soft_limit != 0 )	


struct syslog
{
   int facility ;
	int level ;
} ;

struct log
{
	logtype_e log_type ;
	struct filelog fl ;
	struct syslog sl ;
} ;

#define FILELOG( lp )				(&(lp)->fl)
#define SYSLOG( lp )					(&(lp)->sl)

#endif	/* LOG_H */

